/* A packrat parser generated by PackCC 1.2.2 */

#ifndef PCC_INCLUDED_SCHEMA_TYPE_PARSE_H
#define PCC_INCLUDED_SCHEMA_TYPE_PARSE_H


#include "maestro/status.h"
#include <stdbool.h>
#include <stdint.h>

/** abstract parser input type */
struct mstro_stp_parser_ctx;

enum mstro_stp_val_kind {
  /** error node */
  MSTRO_STP_ERROR = 0,
  /** plain values, should not be visible in final parse result nodes, but appear during parse */
  MSTRO_STP_INTVAL,
  MSTRO_STP_UINTVAL,
  MSTRO_STP_FLOATVAL,
  MSTRO_STP_DOUBLEVAL,
  MSTRO_STP_STRVAL,
  MSTRO_STP_BOOLVAL,
  MSTRO_STP_MININT = 10,
  MSTRO_STP_MINUINT,
  MSTRO_STP_MINFLOAT,
  MSTRO_STP_MINDOUBLE,
  MSTRO_STP_MAXINT,
  MSTRO_STP_MAXUINT,
  MSTRO_STP_MAXFLOAT,
  MSTRO_STP_MAXDOUBLE,
  MSTRO_STP_EXCLSTR = 20,
  MSTRO_STP_ICASE,
  MSTRO_STP_NAME,
  MSTRO_STP_LIST,
  MSTRO_STP_TIMESTAMP,  /* externally will be converted to RFC3339 regex */

  /** user-facing node types */
  MSTRO_STP_BOOL = 64,
  MSTRO_STP_UINT,
  MSTRO_STP_INT,
  MSTRO_STP_FLOAT,
  MSTRO_STP_DOUBLE,
  MSTRO_STP_STR,
  MSTRO_STP_REGEX,
  MSTRO_STP_BLOB,
  MSTRO_STP_POINTER,
  MSTRO_STP_MMBLAYOUT

};

/** User-facing: Protobuf imposes a size limit on strings and blobs
 ** (because they need to fit a single message) */

#define MSTRO_STP_VAL_SIZE_MAX ((uint64_t) 1U<<31)

/** User-facing: the parsed type. This is also serving as
 ** documentation for the permitted restrictions for types. */

struct mstro_stp_val {
  enum mstro_stp_val_kind kind;
  union {
    char    *errmsg;

    /** values arising during parse, but not showing up in user-facing parse nodes */
    bool     boolval;
    int64_t  intval;
    uint64_t uintval;
    float    floatval;
    double   doubleval;
    char    *strval;
    uint64_t minuintval;
    uint64_t maxuintval;
    int64_t  minintval;
    int64_t  maxintval;
    float    minfloatval;
    double   mindoubleval;
    float    maxfloatval;
    double   maxdoubleval;
    char    *exclstrval;
    bool     icase;
    char    *nameval;
    struct {
      struct mstro_stp_val *list_entry;
      struct mstro_stp_val *list_tail;
    };

    struct {
      int64_t int_min;
      int64_t int_max;
    };

    /** restricted uint type */
    struct {
      uint64_t uint_min;
      uint64_t uint_max;
    };

   struct {
     float    float_min;
     float    float_max;
     };

   struct {
     double   double_min;
     double   double_max;
     };

   struct {
     uint64_t str_minlen;
     uint64_t str_maxlen;
     char    *str_excludedchars;
     };

   struct {
     size_t   regex_numpatterns;
     char   **regex_patterns; /**< num_patterns strings, concatenated as alternative regexes */
     char    *regex_name;
     bool     regex_ignorecase;
     };

   struct {
     uint64_t blob_minlen;
     uint64_t blob_maxlen;
     };
   struct {
     uint64_t mmblayout_minlen;
     uint64_t mmblayout_maxlen;
    };
   };

};


/** User-facing type parser interface: Parse a type specification*/
mstro_status
mstro_schema_type_parse(const char *string, struct mstro_stp_val **res);

/** User-facing: dispose a parsed type value */
mstro_status
mstro_stp_val_dispose(struct mstro_stp_val *v);



#ifdef __cplusplus
extern "C" {
#endif

typedef struct mstro_stp_context_tag mstro_stp_context_t;

mstro_stp_context_t *mstro_stp_create(struct mstro_stp_parser_ctx *auxil);
int mstro_stp_parse(mstro_stp_context_t *ctx, struct mstro_stp_val **ret);
void mstro_stp_destroy(mstro_stp_context_t *ctx);

#ifdef __cplusplus
}
#endif

#endif /* !PCC_INCLUDED_SCHEMA_TYPE_PARSE_H */
