/* A packrat parser generated by PackCC 1.2.2 */

#ifndef PCC_INCLUDED_CDO_SEL_PARSE_H
#define PCC_INCLUDED_CDO_SEL_PARSE_H


#include "maestro/status.h"
#include <stdbool.h>
#include <stdint.h>
#include "maestro/attributes.h"
#include "attributes/maestro-schema.h"

/** abstract parser input type */
struct mstro_csq_parser_ctx;

/** parsed query node type tags */
enum mstro_csq_val_kind {
   /** error node */
   MSTRO_CSQ_ERROR = 0,
   MSTRO_CSQ_STRING,
   /* nested nodes */
   /** OR */
   MSTRO_CSQ_OR,
   /** AND */
   MSTRO_CSQ_AND,
   /* singletons are converted to 1-element OR;
      empty AND is 'always-true' selector
      empty OR is 'always-false' selector
    */
   /* unary ops */
   MSTRO_CSQ_OP_HAS,
   /* binary ops */
   MSTRO_CSQ_OP_LT,
   MSTRO_CSQ_OP_LE,
   MSTRO_CSQ_OP_GT,
   MSTRO_CSQ_OP_GE,
   MSTRO_CSQ_OP_EQ,
   MSTRO_CSQ_OP_NEQ,
   MSTRO_CSQ_OP_RMATCH,
   MSTRO_CSQ_OP_RMATCH_ICASE,
};

/** User-facing: the parsed query.

    Lots of strings in here, because
    keys must be interpreted in a schema, and values must be parsed
    according to key type. */

struct mstro_csq_val {
   enum mstro_csq_val_kind kind;
   union {
      char    *errmsg;
      char    *strval;
      /* OR */
      struct {
        struct mstro_csq_val *clauses;
      } or;
      /* AND */
      struct {
        struct mstro_csq_val *terms;
      } and;
      /* unary ops */
      struct {
        bool not;
        char *key;
        /* filled at validation time by schema lookup: */
        mstro_schema_attribute kattr;
      } has;
      /* binary ops */
      struct {
        char *lhs;
        /* filled at validation time by schema lookup: */
        mstro_schema_attribute lhs_attr;
        char *rhs;
      } kv_op;
    };
   /** singly-linked list chaining (for terms and clauses) */
   struct mstro_csq_val *next;
};

/** User-facing type parser interface: Parse a query */
mstro_status
mstro_selector_parse(const char *string, struct mstro_csq_val **res);

/** User-facing: dispose a parsed type value */
mstro_status
mstro_csq_val_dispose(struct mstro_csq_val *v);



#ifdef __cplusplus
extern "C" {
#endif

typedef struct mstro_csq_context_tag mstro_csq_context_t;

mstro_csq_context_t *mstro_csq_create(struct mstro_csq_parser_ctx *auxil);
int mstro_csq_parse(mstro_csq_context_t *ctx, struct mstro_csq_val **ret);
void mstro_csq_destroy(mstro_csq_context_t *ctx);

#ifdef __cplusplus
}
#endif

#endif /* !PCC_INCLUDED_CDO_SEL_PARSE_H */
