#include <stdio.h>
#include <assert.h>
#include "maestro.h"

#include "ecmwf_config.h"
#include <unistd.h>

int main(int argc, char *argv[])
{
    assert(MSTRO_OK == mstro_init(getenv("MSTRO_WORKFLOW_NAME"), getenv("MSTRO_COMPONENT_NAME"), 0));

    mstro_cdo cdo = NULL;
    assert(MSTRO_OK == mstro_cdo_declare("my-cdo-1", MSTRO_ATTR_DEFAULT, &cdo));
    int64_t step = 2;
    int64_t number = 1;
    assert(MSTRO_OK == mstro_cdo_attribute_set(cdo, ".maestro.ecmwf.step", (void **)&step, true));
    assert(MSTRO_OK == mstro_cdo_attribute_set(cdo, ".maestro.ecmwf.number", (void **)&number, true));
    assert(MSTRO_OK == mstro_cdo_seal(cdo));
    assert(MSTRO_OK == mstro_cdo_offer(cdo));
    sleep(5); // sleep until we sync with startup of consumer (=fix acknowledge issue)
    assert(MSTRO_OK == mstro_cdo_withdraw(cdo));
    assert(MSTRO_OK == mstro_cdo_dispose(cdo));
    assert(MSTRO_OK == mstro_finalize());

    return 0;    
}
