#include <stdio.h>
#include <assert.h>
#include "maestro.h"

int main(int argc, char *argv[])
{
    assert(MSTRO_OK == mstro_init(getenv("MSTRO_WORKFLOW_NAME"), getenv("MSTRO_COMPONENT_NAME"), 0));

    mstro_cdo cdo;

    assert(MSTRO_OK == mstro_cdo_declare("my-cdo-0", MSTRO_ATTR_DEFAULT, &cdo));
    assert(MSTRO_OK == mstro_cdo_seal(cdo));
    assert(MSTRO_OK == mstro_cdo_offer(cdo));

    printf("Withdrawing and disposing my-cdo-0");
    assert(MSTRO_OK == mstro_cdo_withdraw(cdo));
    assert(MSTRO_OK == mstro_cdo_dispose(cdo));

    assert(MSTRO_OK == mstro_finalize());
    return 0;    
}
